/**
 * Create a table from CHARSET to Unicode.
 * This is a good test for the ByteToChar converter.
 *
 * @author Bruno Haible
 */
import java.io.*;
import sun.io.ByteToCharConverter;
import sun.io.MalformedInputException;
public class table_from {
  static String toHexString1 (int i) {
    return new String(new char[] { "0123456789ABCDEF".charAt(i) });
  }
  static String toHexString2 (int i) {
    return  toHexString1((i>>4)&0x0f)
           +toHexString1(i&0x0f);
  }
  static String toHexString4 (int i) {
    return  toHexString1((i>>12)&0x0f)
           +toHexString1((i>>8)&0x0f)
           +toHexString1((i>>4)&0x0f)
           +toHexString1(i&0x0f);
  }
  public static void main (String[] args) {
    if (args.length != 1) {
      System.err.println("Usage: java table_from charset");
      System.exit(1);
    }
    String charset = args[0];
    ByteToCharConverter converter = null;
    try {
      converter = ByteToCharConverter.getConverter(charset);
    } catch (UnsupportedEncodingException e) {
      System.err.println("no converter for "+charset);
      System.exit(1);
    }
    for (int i0 = 0; i0 < 0x100; i0++) {
      try {
        byte[] in = new byte[] { (byte)i0 };
        char[] out = converter.convertAll(in);
        if (!(out.length == 1 && out[0] == 0xfffd)) {
          System.out.print("0x"+toHexString2(i0)+"\t0x");
          for (int j = 0; j < out.length; j++)
            System.out.print(toHexString4(out[j]));
          System.out.println();
        }
      } catch (MalformedInputException e0) {
        for (int i1 = 0; i1 < 0x100; i1++) {
          try {
            byte[] in = new byte[] { (byte)i0, (byte)i1 };
            char[] out = converter.convertAll(in);
            if (!(out.length == 1 && out[0] == 0xfffd)) {
              System.out.print("0x"+toHexString2(i0)+toHexString2(i1)+"\t0x");
              for (int j = 0; j < out.length; j++)
                System.out.print(toHexString4(out[j]));
              System.out.println();
            }
          } catch (MalformedInputException e1) {
            for (int i2 = 0; i2 < 0x100; i2++) {
              try {
                byte[] in = new byte[] { (byte)i0, (byte)i1, (byte)i2 };
                char[] out = converter.convertAll(in);
                if (!(out.length == 1 && out[0] == 0xfffd)) {
                  System.out.print("0x"+toHexString2(i0)+toHexString2(i1)+toHexString2(i2)+"\t0x");
                  for (int j = 0; j < out.length; j++)
                    System.out.print(toHexString4(out[j]));
                  System.out.println();
                }
              } catch (MalformedInputException e2) {
                for (int i3 = 0; i3 < 0x100; i3++) {
                  try {
                    byte[] in = new byte[] { (byte)i0, (byte)i1, (byte)i2, (byte)i3 };
                    char[] out = converter.convertAll(in);
                    if (!(out.length == 1 && out[0] == 0xfffd)) {
                      System.out.print("0x"+toHexString2(i0)+toHexString2(i1)+toHexString2(i2)+toHexString2(i3)+"\t0x");
                      for (int j = 0; j < out.length; j++)
                        System.out.print(toHexString4(out[j]));
                      System.out.println();
                    }
                  } catch (MalformedInputException e3) {
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}
