/**
 * Create a table from Unicode to CHARSET.
 * This is a good test for the CharToByte converter.
 *
 * @author Bruno Haible
 */
import java.io.*;
import sun.io.CharToByteConverter;
import sun.io.MalformedInputException;
public class table_to {
  static String toHexString1 (int i) {
    return new String(new char[] { "0123456789ABCDEF".charAt(i) });
  }
  static String toHexString2 (int i) {
    return  toHexString1((i>>4)&0x0f)
           +toHexString1(i&0x0f);
  }
  static String toHexString4 (int i) {
    return  toHexString1((i>>12)&0x0f)
           +toHexString1((i>>8)&0x0f)
           +toHexString1((i>>4)&0x0f)
           +toHexString1(i&0x0f);
  }
  public static void main (String[] args) {
    if (args.length != 1) {
      System.err.println("Usage: java table_to charset");
      System.exit(1);
    }
    String charset = args[0];
    CharToByteConverter converter = null;
    try {
      converter = CharToByteConverter.getConverter(charset);
    } catch (UnsupportedEncodingException e) {
      System.err.println("no converter for "+charset);
      System.exit(1);
    }
    byte[] subst1 = new byte[] { 0 };
    byte[] subst2 = new byte[] { '?' };
    for (int i = 0; i < 0x110000; i++) {
      char[] in =
        (i < 0x10000
         ? new char[] { (char)i }
         : new char[] { (char)(0xd800 + ((i - 0x10000) >> 10)),
                        (char)(0xdc00 + ((i - 0x10000) & 0x3ff)) });
      try {
        converter.setSubstitutionBytes(subst1);
        byte[] out1 = converter.convertAll(in);
        converter.setSubstitutionBytes(subst2);
        byte[] out2 = converter.convertAll(in);
        if (!(((out1.length == 1 && out1[0] == subst1[0])
               || (out1.length == 2 && out1[0] == subst1[0] && out1[1] == subst1[0]))
              && ((out2.length == 1 && out2[0] == subst2[0])
                  || (out2.length == 2 && out2[0] == subst2[0] && out2[1] == subst2[0])))) {
          System.out.print("0x");
          for (int j = 0; j < out1.length; j++)
            System.out.print(toHexString2(out1[j]));
          System.out.println("\t0x" + (i<0x10000 ? toHexString4(i) : Integer.toHexString(i).toUpperCase()));
        }
      } catch (MalformedInputException e) {
      }
    }
  }
}
