#!/bin/sh
# Produce individual character set conversion tables from UNIHAN.TXT.

# NB: "This agrees" means that the Hanzi part (regexp "0x\(4[EF]\|[5-9].\|A[0-9]\|FA\)..") agrees.

# This agrees with OTHER/BIG5.TXT.
grep '^U.*kBigFive	' UNIHAN.TXT | sed -e 's,^U+\(....\)	kBigFive	\(....\)$,0x\2	0x\1,' | sort > UNIHAN-BIG5.TXT

grep '^U.*kCCCII	' UNIHAN.TXT | sed -e 's,^U+\(....\)	kCCCII	\(......\)$,0x\2	0x\1,' | sort > UNIHAN-CCCII.TXT

# This agrees with OTHER/CNS11643.TXT
grep '^U.*kCNS1986	' UNIHAN.TXT | sed -e 's,^U+\(....\)	kCNS1986	\(.\)-\(....\)$,0x\2\3	0x\1,' | sort > UNIHAN-CNS116431986.TXT

# This is not correct; plane 3 of CNS11643-1992 does not contain the full plane 14 of CNS11643-1986.
#grep '^U.*kCNS1992	' UNIHAN.TXT | sed -e 's,^U+\(....\)	kCNS1992	\(.\)-\(....\)$,0x\2\3	0x\1,' | sort > UNIHAN-CNS116431992.TXT 

# This agrees with GB/GB2312.TXT
grep '^U.*kGB0	' UNIHAN.TXT | sed -e 's,^U+\(....\)	kGB0	\(....\)$,0x\2	0x\1,' | sort | ../../kuten2table > UNIHAN-GB2312.TXT

# This agrees with GB/GB12345.TXT
grep '^U.*kGB1	' UNIHAN.TXT | sed -e 's,^U+\(....\)	kGB1	\(....\)$,0x\2	0x\1,' | sort | ../../kuten2table > UNIHAN-GB12345.TXT

grep '^U.*kGB8	' UNIHAN.TXT | sed -e 's,^U+\(....\)	kGB8	\(....\)$,0x\2	0x\1,' | sort | ../../kuten2table > UNIHAN-GB8565.TXT

# This agrees with JIS/JIS0208.TXT
grep '^U.*kJis0	' UNIHAN.TXT | sed -e 's,^U+\(....\)	kJis0	\(....\)$,0x\2	0x\1,' | sort | ../../kuten2table > UNIHAN-JISX0208.TXT

# This agrees with JIS/JIS0212.TXT
grep '^U.*kJis1	' UNIHAN.TXT | sed -e 's,^U+\(....\)	kJis1	\(....\)$,0x\2	0x\1,' | sort | ../../kuten2table > UNIHAN-JISX0212.TXT

# This agrees with KSC/KSX1001.TXT
grep '^U.*kKSC0	' UNIHAN.TXT | sed -e 's,^U+\(....\)	kKSC0	\(....\)$,0x\2	0x\1,' | sort | ../../kuten2table > UNIHAN-KSX1001.TXT

grep '^U.*kKSC1	' UNIHAN.TXT | sed -e 's,^U+\(....\)	kKSC1	\(....\)$,0x\2	0x\1,' | sort | ../../kuten2table > UNIHAN-KSX1002.TXT
